/*===============================================================================================
 ubN   : C
 @\     : I2CoRɂăZT[̃f[^擾CUARTɂ̃f[^𑗂B
              : ܂C
 Revision     :1.00
 Date         :2015/02/23
 Author       :S.Shinagawa
 COPYRIGHT (C) NOGUE-LAB.COM ALL RIGHTS RESERVED
================================================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#include <wiringPi.h>
#include <wiringSerial.h>
#include "drv_public.h"

/*===============================================================================================
 萔錾
================================================================================================*/
#define BUFF_LEN		(1024)		/*obt@̃f[^										*/
#define BUFF_STR_LEN	(256)		/*obt@̕f[^									*/
#define ABS_VAL			(8000)		/*ZT[̒l臒l										*/
#define WAIT_COUNT		(100)		/*oɎ̉o܂ł̃EFCgJEg			
									@1JEg3msec*/
/*===============================================================================================
 O[oϐ
================================================================================================*/
static char gBuffer[BUFF_LEN];				/*ꎞf[^i[pobt@							 */
static	char *gI2cFileName = "/dev/i2c-1";	/*I2ChCot@C								*/

/*===============================================================================================
		I2c̃|[gI[v
	
		int DRV_openI2cC(char *pI2cDev)
	
		pSerialDev	char *	IN	foCX
	
߂l		DRV_OK	I
			DRV_NG	ُI

@\	I2CTp̃|[gI[vB
			I2C|[g̃I[v́CgI2cFd̃t@CfBXNv^ϐɓB
	
L	I2CfoCX1݂̂z肵čꂽ̂̂߁CI2CfoCXꍇ́C
			gI2cFd̎舵C舵悤ɕύXȂ΂ȂȂ

C	
================================================================================================*/
int main_demoFishCatchSensor(void)
{
	int fd;							/*t@CfBXNv^									*/
	int slaveAddress = 0x6A;		/*pxZT[I2C Slave ̃AhX						*/
	unsigned char buf[258];			/*ꎞf[^i[pobt@									*/
	int i;							/*forpindexp											*/
	int rlt;						/*ʊi[pϐ											*/
	unsigned int addr;				/*pxZT[̎QƐAhXi[pϐ					*/
	unsigned int writeLen,readLen;	/*݁CǍ݃f[^i[ϐ							*/
	int recvChar,recvLen;			/*UARTf[^i[ϐCUARTMf[^i[ϐ				*/
	int xVal, yVal, zVal;			/*XCYCZ̒li[ϐ									*/
	unsigned int valX_h=0, valX_l=0, valY_h=0, valY_l=0, valZ_h=0, valZ_l=0;	/*XCYCZ
									@ꂼ̒l2bytẽf[^1byteM邽߁Cʃrb
									@gƉʃrbg𕪂ăf[^擾邽߂̕ϐ			*/
	int waitCount=0;				/*AŏoȂ߂̃JEgi[ϐ					*/
	FILE *fp;						/*ُ픭̃Oo͗pt@C|C^					*/
	time_t timer;					/*s̎Ԏ擾pϐ									*/
	struct tm *date;				/*s̎Ԏ擾pϐ									*/
	
	timer = time(NULL);          	/*oߎԂ擾											*/
	date = localtime(&timer);    	/*oߎԂԂ\\ date ɕϊ					*/
	fp = fopen("/home/pi/Program/AutoFishDemo/log.txt","a+");
	fprintf(fp,"---------------------------------------------\n");
	fprintf(fp,"%s\n", asctime(date));			/*\ date 𕶎ɕϊĕ\			*/
	fflush(fp);									/*tbVăf[^t@Cփf[^	*/
	printf("%s\n", asctime(date));				/*\ date 𕶎ɕϊĕ\			*/

	/*VAʐMpobt@̏BNULLI[Ŗ߂B*/
	memset(gBuffer, 0, BUFF_LEN);

	rlt = DRV_openI2c(gI2cFileName);			/*I2CI[v									*/
	if(rlt != DRV_OK){
		fprintf(fp,"DRV_openI2c error\n");
		fclose(fp);
		return -1;
	}

	rlt = DRV_setSlaveAddr(slaveAddress);		/*I2C̃X[uAhXݒ					*/
	if(rlt != DRV_OK){
		fprintf(fp,"DRV_setSlaveAddr error\n");
		fclose(fp);
		return -1;
	}

	addr = 0x0f;								/*L3GD20WHO_AM_If[^i[ĂAhX*/
	readLen = 1;
	rlt= DRV_readI2c(addr,buf,readLen,ADDR_TYPE_1BYTE);	/*wAhX̃f[^擾				*/
	if(rlt != DRV_OK){
		fprintf(fp,"DRV_readI2c error\n");
		fclose(fp);
		return -1;
	}

	/*擾f[^̕\*/
	for(i=0; i<readLen; i++){				
		printf("[%02x] : %02x\n",i+addr,buf[i]);
	}
	printf("\n\n");

	addr = 0x0;
	readLen = 57;

	for(i=0; i<readLen; i++){					/*L3GD2057bytẽf[^\					*/
		rlt= DRV_readI2c(addr+i,buf,1,ADDR_TYPE_1BYTE);
		if(rlt != DRV_OK){
			return -1;
		}
		printf("[%02x] : %02x\n",i+addr,buf[0]);
	}	
	
	printf("\n\n");

	addr = 0x20;
	writeLen = 1;
	buf[0] = 0x0F;								/*L3GD20̊e̋@\Enableɂ				*/
	rlt= DRV_writeI2c(addr,buf,writeLen,ADDR_TYPE_1BYTE);
	if(rlt != DRV_OK){
		printf("check 1\r\n");
		return -1;
	}

	addr = 0x20;
	readLen = 1;

	rlt= DRV_readI2c(addr,buf,readLen,ADDR_TYPE_1BYTE);	/*L3GD200x20̃AhX̒l`FbN	*/
	if(rlt != DRV_OK){
		fprintf(fp,"DRV_readI2c error\n");
		fclose(fp);
		return -1;
	}
	printf("[%02x] : %02x\n",addr,buf[0]);

	printf("\n\n");

	/* VA|[gI[v */
	fd = serialOpen("/dev/ttyAMA0",115200);
	if(fd<0){
		fprintf(fp,"serialOpen error\n");
		fclose(fp);
		printf("can not open serialport");
		return -1;
	}

	/*N̊mFo*/
	system("aplay -q /home/pi/Program/AutoFishDemo/start.wav &");
	printf("Start Fish Catch Sensor Application\n");
	serialFlush(fd);
	recvChar=0;

	addr = 0x28;		/*3̒l擾邽߂̃x[XAhXݒ	*/
	readLen = 6;		/*6bytẽf[^ݒ						*/
	gBuffer[0] = 0x67;	/*UART̃f[^o͗pwb_				*/
	gBuffer[1] = 0x06;	/*UART̃f[^o̓f[^				*/
	while(1){
		serialPutchar(fd,gBuffer[0]);	/*wb_f[^UARTMi1byte)	*/
		serialPutchar(fd,gBuffer[1]);	/*f[^UARTMi1byte)		*/
		for(i=0; i<readLen; i++){		/*XCYCZ̃f[^擾				*/
			rlt= DRV_readI2c(addr+i,buf,1,ADDR_TYPE_1BYTE);	/*ZT[̑ΏۃAhXf[^擾*/
			if(rlt != DRV_OK){
				return -1;
			}
			serialPutchar(fd,buf[0]);	/*擾f[^UARTMi1byte)	*/
			
			switch(i){
			case 0:
				valX_l = (unsigned int)buf[0];	/*0x28AhX́CX̉1byte̒lɐݒ*/
				break;
			case 1:
				valX_h = (unsigned int)buf[0];	/*0x29AhX́CX̏1byte̒lɐݒ*/
				break;
			case 2:
				valY_l = (unsigned int)buf[0];	/*0x2AAhX́CỶ1byte̒lɐݒ*/
				break;
			case 3:
				valY_h = (unsigned int)buf[0];	/*0x2BAhX́CY̏1byte̒lɐݒ*/
				break;
			case 4:
				valZ_l = (unsigned int)buf[0];	/*0x2CAhX́CZ̉1byte̒lɐݒ*/
				break;
			case 5:
				valZ_h = (unsigned int)buf[0];	/*0x2DAhX́CZ̏1byte̒lɐݒ*/
				break;
			default:
				break;
			}
		}
		
		xVal = (int)((valX_h << 8) | (valX_l));		/*X̏ʁCʂ̒l킹			*/
		yVal = (int)((valY_h << 8) | (valY_l));		/*Y̏ʁCʂ̒l킹			*/
		zVal = (int)((valZ_h << 8) | (valZ_l));		/*Z̏ʁCʂ̒l킹			*/
		if (xVal >= 32768){					/*}CiX̒l̏ꍇCl}CiX̒lɕύX*/
			xVal = xVal - 65535;
		}
		if (yVal >= 32768){					/*}CiX̒l̏ꍇCl}CiX̒lɕύX*/
			yVal = yVal - 65535;
		}
		if (zVal >= 32768){					/*}CiX̒l̏ꍇCl}CiX̒lɕύX*/
			zVal = zVal - 65535;
		}
				
		/*Βl̒lɂ臒lABS_VAL𒴂Ă邩`FbNCĂΉoB*/
		if((abs(xVal) > ABS_VAL) || (abs(yVal) > ABS_VAL) || (abs(zVal) > ABS_VAL)){
			if(waitCount == 0){
				system("aplay -q /home/pi/Program/AutoFishDemo/alerm.wav &");
				waitCount++;
			}
			else if(waitCount > WAIT_COUNT){
				waitCount = 0;
			}
			else{
				waitCount++;
			}
		}
		
		/*UARTɃf[^ĂĂ邩`FbN*/
		recvLen = serialDataAvail(fd);
		if(recvLen > 0){
			recvChar = serialGetchar(fd);	/*ĂĂꍇ1bytef[^擾*/
			if(recvChar == 101){			/*eR}h̏ꍇCStartw܂ő҂*/
				system("aplay -q /home/pi/Program/AutoFishDemo/stop.wav &");
				printf("Stop Fish Catch Sensor Application\n");
				while(1){
					recvChar = serialGetchar(fd);
					if(recvChar == 115){	/*Startw̏ꍇCҋ@𔲂*/
						system("aplay -q /home/pi/Program/AutoFishDemo/start.wav &");
						printf("Start Fish Catch Sensor Application\n");
						serialFlush(fd);
						recvChar=0;
						break;
					}
				}
			}
		}
	}	
	DRV_closeI2c();
	fclose(fp);
}

/*===============================================================================================
		C֐
	
		int main(void)
	
		Ȃ
	
߂l		0		I

@\	main_demoFishCatchSensor𖳌ɎsB
			G[̏ꍇ́C5bWaitčēxsB
	
L	

C	
================================================================================================*/
int main(int argc, char **argv){
	int rlt;
	while(1){
		rlt = main_demoFishCatchSensor();
		if(rlt != 0){
			sleep(1);			
			system("aplay -q /home/pi/Program/AutoFishDemo/stop.wav &");
			printf("fishDemo restart wait 5sec\r\n");
			sleep(5);
		}
	}
	return 0;
}
/*=========================================== END ==============================================*/

